package moteView;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.Dimension;
import java.awt.GridBagLayout;
import java.awt.FlowLayout;
import javax.swing.BorderFactory;
import javax.swing.border.EtchedBorder;
import javax.swing.JTextField;
import java.awt.GridBagConstraints;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JTabbedPane;

public class MoteViewGui extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JPanel mainPanel = null;

	private JPanel mote1Panel = null;

	private JTextField distance0To1TextField = null;

	private JLabel distance0To1Label = null;

	private JPanel mote2Panel = null;

	private JLabel distance0To2Label1 = null;

	private JTextField distance0To2TextField = null;

	private JLabel distance1To2Label = null;

	private JTextField distance1To2TextField = null;

	private JPanel mote3Panel = null;

	private JLabel distance0To3Label = null;

	private JTextField distance0To3TextField = null;

	private JLabel distance1To3Label = null;

	private JTextField distance1To3TextField = null;

	private JLabel distance2To3Label = null;

	private JTextField distance2To3TextField = null;

	private JButton configSaveButton = null;

	
	private MoteViewController controller;

	private JTabbedPane mainTabbedPane = null;

	private JPanel socketPanel = null;

	private JLabel addressLabel = null;

	private JTextField addressTextField = null;

	private JLabel portLabel = null;

	private JTextField portTextField = null;

	private JButton socketButton = null;

	/**
	 * This is the default constructor
	 */
	public MoteViewGui(MoteViewController c) {
		super();
		initialize();
		controller = c;
		
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
	}
	
	public void displayInfoDialog(String header, String message) {
		JOptionPane.showMessageDialog(this,header,message,JOptionPane.INFORMATION_MESSAGE);
	}
	
	public void displayErrorDialog(String header, String message) {
		JOptionPane.showMessageDialog(this,header,message,JOptionPane.ERROR_MESSAGE);
	}
	
	public void addDisplayTab(DisplayPanel tab, String name) {
		getMainTabbedPane().addTab(name, tab);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(628, 393);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getMainTabbedPane(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes mainPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMainPanel() {
		if (mainPanel == null) {
			mainPanel = new JPanel();
			mainPanel.setLayout(new FlowLayout());
			mainPanel.add(getMote1Panel(), null);
			mainPanel.add(getMote2Panel(), null);
			mainPanel.add(getMote3Panel(), null);
			mainPanel.add(getConfigSaveButton(), null);
			mainPanel.add(getSocketPanel(), null);
		}
		return mainPanel;
	}

	/**
	 * This method initializes mote1Panel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMote1Panel() {
		if (mote1Panel == null) {
			distance0To1Label = new JLabel();
			distance0To1Label.setText("Distance: 0 to 1");
			mote1Panel = new JPanel();
			mote1Panel.setLayout(new FlowLayout());
			mote1Panel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
			mote1Panel.add(distance0To1Label, null);
			mote1Panel.add(getDistance0To1TextField(), null);
		}
		return mote1Panel;
	}

	/**
	 * This method initializes distance0To1TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDistance0To1TextField() {
		if (distance0To1TextField == null) {
			distance0To1TextField = new JTextField();
			distance0To1TextField.setColumns(4);
			distance0To1TextField.setText("96");
		}
		return distance0To1TextField;
	}

	/**
	 * This method initializes mote2Panel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMote2Panel() {
		if (mote2Panel == null) {
			distance1To2Label = new JLabel();
			distance1To2Label.setText("Distance: 1 to 2");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints1.weightx = 1.0;
			distance0To2Label1 = new JLabel();
			distance0To2Label1.setText("Distance: 0 to 2");
			mote2Panel = new JPanel();
			mote2Panel.setLayout(new FlowLayout());
			mote2Panel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
			mote2Panel.add(distance0To2Label1, null);
			mote2Panel.add(getDistance0To2TextField(), null);
			mote2Panel.add(distance1To2Label, null);
			mote2Panel.add(getDistance1To2TextField(), null);
		}
		return mote2Panel;
	}

	/**
	 * This method initializes distance0To2TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDistance0To2TextField() {
		if (distance0To2TextField == null) {
			distance0To2TextField = new JTextField();
			distance0To2TextField.setColumns(4);
			distance0To2TextField.setText("141");
		}
		return distance0To2TextField;
	}

	/**
	 * This method initializes distance1To2TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDistance1To2TextField() {
		if (distance1To2TextField == null) {
			distance1To2TextField = new JTextField();
			distance1To2TextField.setColumns(4);
			distance1To2TextField.setText("93");
		}
		return distance1To2TextField;
	}

	/**
	 * This method initializes mote3Panel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMote3Panel() {
		if (mote3Panel == null) {
			distance2To3Label = new JLabel();
			distance2To3Label.setText("Distance: 2 to 3");
			distance1To3Label = new JLabel();
			distance1To3Label.setText("Distance: 1 to 3");
			distance0To3Label = new JLabel();
			distance0To3Label.setText("Distance: 0 to 3");
			mote3Panel = new JPanel();
			mote3Panel.setLayout(new FlowLayout());
			mote3Panel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
			mote3Panel.add(distance0To3Label, null);
			mote3Panel.add(getDistance0To3TextField(), null);
			mote3Panel.add(distance1To3Label, null);
			mote3Panel.add(getDistance1To3TextField(), null);
			mote3Panel.add(distance2To3Label, null);
			mote3Panel.add(getDistance2To3TextField(), null);
		}
		return mote3Panel;
	}

	/**
	 * This method initializes distance0To3TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDistance0To3TextField() {
		if (distance0To3TextField == null) {
			distance0To3TextField = new JTextField();
			distance0To3TextField.setColumns(4);
			distance0To3TextField.setText("96");
		}
		return distance0To3TextField;
	}

	/**
	 * This method initializes distance1To3TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDistance1To3TextField() {
		if (distance1To3TextField == null) {
			distance1To3TextField = new JTextField();
			distance1To3TextField.setColumns(4);
			distance1To3TextField.setText("111");
		}
		return distance1To3TextField;
	}

	/**
	 * This method initializes distance2To3TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDistance2To3TextField() {
		if (distance2To3TextField == null) {
			distance2To3TextField = new JTextField();
			distance2To3TextField.setColumns(4);
			distance2To3TextField.setText("75");
		}
		return distance2To3TextField;
	}

	/**
	 * This method initializes configSaveButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getConfigSaveButton() {
		if (configSaveButton == null) {
			configSaveButton = new JButton();
			configSaveButton.setText("Save");
			configSaveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					//System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					controller.loadConfiguration(getDistance0To1TextField().getText(),
							getDistance0To2TextField().getText(), 
							getDistance1To2TextField().getText(), 
							getDistance0To3TextField().getText(), 
							getDistance1To3TextField().getText(), 
							getDistance2To3TextField().getText());
				}
			});
		}
		return configSaveButton;
	}

	/**
	 * This method initializes mainTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getMainTabbedPane() {
		if (mainTabbedPane == null) {
			mainTabbedPane = new JTabbedPane();
			mainTabbedPane.addTab("Config", null, getMainPanel(), null);
		}
		return mainTabbedPane;
	}

	/**
	 * This method initializes socketPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getSocketPanel() {
		if (socketPanel == null) {
			portLabel = new JLabel();
			portLabel.setText("Socket Port");
			addressLabel = new JLabel();
			addressLabel.setText("Socket Address");
			socketPanel = new JPanel();
			socketPanel.setLayout(new FlowLayout());
			socketPanel.add(addressLabel, null);
			socketPanel.add(getAddressTextField(), null);
			socketPanel.add(portLabel, null);
			socketPanel.add(getPortTextField(), null);
			socketPanel.add(getSocketButton(), null);
		}
		return socketPanel;
	}

	/**
	 * This method initializes addressTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getAddressTextField() {
		if (addressTextField == null) {
			addressTextField = new JTextField();
			addressTextField.setColumns(10);
			try{
				addressTextField.setText(java.net.InetAddress.getLocalHost().getHostAddress());
			} catch(Exception ex) {}
			
		}
		return addressTextField;
	}

	/**
	 * This method initializes portTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPortTextField() {
		if (portTextField == null) {
			portTextField = new JTextField();
			portTextField.setColumns(5);
			portTextField.setText("9001");
		}
		return portTextField;
	}

	/**
	 * This method initializes socketButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSocketButton() {
		if (socketButton == null) {
			socketButton = new JButton();
			socketButton.setText("Connect");
			socketButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					//System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					controller.startListening(addressTextField.getText(), portTextField.getText());
				}
			});
		}
		return socketButton;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
