package moteView;

import java.util.*;

public class RatioTable {
	
	double[] physicalDistanceFrom0;
	double[] physicalDistanceFrom1;
	double[] physicalDistanceFrom2;
	double[] physicalDistanceFrom3;
	double[] physicalDistanceFrom4;
	
	int[] signalStrengthFrom0;
	int[] signalStrengthFrom1;
	int[] signalStrengthFrom2;
	int[] signalStrengthFrom3;
	int[] signalStrengthFrom4;
	
	boolean[] signalRecievedFrom0;
	boolean[] signalRecievedFrom1;
	boolean[] signalRecievedFrom2;
	boolean[] signalRecievedFrom3;
	boolean[] signalRecievedFrom4;
	
	boolean[] signalsIn;
	
	private double[] ratios;
	
	private boolean ready=false;
	
	private boolean DEBUG;
	
	public RatioTable(boolean debug) {
		DEBUG = debug;
		physicalDistanceFrom0 = new double[5];
		physicalDistanceFrom1 = new double[5];
		physicalDistanceFrom2 = new double[5];
		physicalDistanceFrom3 = new double[5];
		physicalDistanceFrom4 = new double[5];
		
		signalStrengthFrom0 = new int[5];
		signalStrengthFrom1 = new int[5];
		signalStrengthFrom2 = new int[5];
		signalStrengthFrom3 = new int[5];
		signalStrengthFrom4 = new int[5];
		
		signalRecievedFrom0 = new boolean[5];
		
		/*for(int i=0; i<5; i++)
			signalRecievedFrom0[i] = false;
		signalRecievedFrom0[0] = true;
		signalRecievedFrom0 = new boolean[5];*/
		
		for(int i=0; i<5; i++) 
			signalRecievedFrom0[i] = false;
		signalRecievedFrom0[0] = true;
		
		signalRecievedFrom1 = new boolean[5];
		for(int i=0; i<5; i++)
			signalRecievedFrom1[i] = false;
		signalRecievedFrom1[1] = true;
		
		signalRecievedFrom2 = new boolean[5];
		for(int i=0; i<5; i++)
			signalRecievedFrom2[i] = false;
		signalRecievedFrom2[2] = true;
		
		signalRecievedFrom3 = new boolean[5];
		for(int i=0; i<5; i++)
			signalRecievedFrom3[i] = false;
		signalRecievedFrom3[3] = true;
		
		signalRecievedFrom4 = new boolean[5];
		for(int i=0; i<5; i++)
			signalRecievedFrom4[i] = false;
		signalRecievedFrom4[4] = true;
		
		signalsIn = new boolean[5];
		for(int i=0; i<5; i++)
			signalsIn[i] = false;
		
		ratios = new double[5];
		//signalsIn[2] = true;
	}
	
	public boolean isReady() {
		if(DEBUG) System.out.println("RatioTable:isReady():ENTER:");
		if(ready) {
			if(DEBUG) System.out.println("RatioTable:isReady():EXIT: "+true);
			return(ready);
		}
		if(!signalsIn[0]) {
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[0] not all in");
			for(int i=0; i<5; i++)
				if(!signalRecievedFrom0[i]) {
					if(DEBUG) System.out.println("RatioTable:isReady():EXIT: no signal from 0 to "+i);
					return(false);
				}
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[0]: "+true);
			signalsIn[0] = true;	
		}
		
		if(!signalsIn[1]) {
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[1] not all in");
			for(int i=0; i<5; i++)
				if(!signalRecievedFrom1[i]) {
					if(DEBUG) System.out.println("RatioTable:isReady():EXIT: no signal from 1 to "+i);
					return(false);
				}
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[1]: "+true);
			signalsIn[1] = true;	
		}
		
		if(!signalsIn[2]) {
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[2] not all in");
			for(int i=0; i<5; i++)
				if(!signalRecievedFrom2[i]) {
					if(DEBUG) System.out.println("RatioTable:isReady():EXIT: no signal from 2 to "+i);
					return(false);
				}
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[2]: "+true);
			signalsIn[2] = true;	
		}
		
		if(!signalsIn[3]) {
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[3] not all in");
			for(int i=0; i<5; i++)
				if(!signalRecievedFrom3[i]) {
					if(DEBUG) System.out.println("RatioTable:isReady():EXIT: no signal from 3 to "+i);
					return(false);
				}
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[3]: "+true);
			signalsIn[3] = true;	
		}
		
		/*if(!signalsIn[4]) {
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[4] not all in");
			for(int i=0; i<5; i++)
				if(!signalRecievedFrom4[i]) {
					if(DEBUG) System.out.println("RatioTable:isReady():EXIT: no signal from 4 to "+i);
					return(false);
				}
			if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: signalsIn[4]: "+true);
			signalsIn[4] = true;	
		}*/
		
		ready = true;
		if(DEBUG) System.out.println("RatioTable:isReady():DEBUG: ready set to true ");
		if(DEBUG) System.out.println("RatioTable:isReady():EXIT: "+ready);
		return(ready);
	}
	
	public void setSignalStrength(int from, int to, int value) {
		switch(from) {
		case 0:
			signalStrengthFrom0[to] = value;
			signalRecievedFrom0[to] = true;
			break;
		case 1:
			signalStrengthFrom1[to] = value;		
			signalRecievedFrom1[to] = true;
			break;
		case 2:
			signalStrengthFrom2[to] = value;
			signalRecievedFrom2[to] = true;
			break;
		case 3:
			signalStrengthFrom3[to] = value;
			signalRecievedFrom3[to] = true;
			break;
		case 4:
			signalStrengthFrom4[to] = value;
			signalRecievedFrom4[to] = true;
			break;
		}
	}
	
	public void setPhysicalDistance(int from, int to, double value) {
		switch(from) {
		case 0:
			physicalDistanceFrom0[to] = value;
			break;
		case 1:
			physicalDistanceFrom1[to] = value;		
			break;
		case 2:
			physicalDistanceFrom2[to] = value;
			break;
		case 3:
			physicalDistanceFrom3[to] = value;
			break;
		case 4:
			physicalDistanceFrom4[to] = value;
			break;
		}
	}
	
	public int getDistanceValue(int from, int to) {
		switch(from) {
		case 0:
			return(int)(physicalDistanceFrom0[to]);
		case 1:
			return(int)(physicalDistanceFrom1[to]);	
		case 2:
			return(int)(physicalDistanceFrom2[to]);
		case 3:
			return(int)(physicalDistanceFrom3[to]);
		case 4:
			return(int)(physicalDistanceFrom4[to]);
		}
		return(-1);
	}
	
	public int getMoteRadius(int from) {
		if(DEBUG) System.out.println("RatioTable:getMoteRadius():ENTER: from: "+from);
		int val;
		switch(from) {
		case 0:
			val = (int)(((signalStrengthFrom0[4]/ratios[0])/*+signalStrengthFrom4[from]/ratios[4])/2d*/));
			if(DEBUG) System.out.println("RatioTable:getMoteRadius():EXIT: val: "+val);
			return(val);
		case 1:
			val = (int)(((signalStrengthFrom1[4]/ratios[1])/*+signalStrengthFrom4[from]/ratios[4])/2d*/));
			if(DEBUG) System.out.println("RatioTable:getMoteRadius():EXIT: val: "+val);
			return(val);
		case 2:
			val = (int)(((signalStrengthFrom2[4]/ratios[2])/*+signalStrengthFrom4[from]/ratios[4])/2d*/));
			if(DEBUG) System.out.println("RatioTable:getMoteRadius():EXIT: val: "+val);
			return(val);
		case 3:
			val = (int)(((signalStrengthFrom3[4]/ratios[3])/*+signalStrengthFrom4[from]/ratios[4])/2d*/));
			if(DEBUG) System.out.println("RatioTable:getMoteRadius():EXIT: val: "+val);
			return(val);
		}
		if(DEBUG) System.out.println("RatioTable:getMoteRadius():EXIT: val: none found");
		return(-1);
	}
	
	public void calculateRatio() {
		if(DEBUG) System.out.println("RatioTable:caclulateRatio():ENTER:");
		ArrayList<Double> ratioList0 = new ArrayList<Double>();
		ArrayList<Double> ratioList1 = new ArrayList<Double>();
		ArrayList<Double> ratioList2 = new ArrayList<Double>();
		ArrayList<Double> ratioList3 = new ArrayList<Double>();
		ArrayList<Double> ratioList4 = new ArrayList<Double>();
		for(int i=0; i<5; i++) {
			if(physicalDistanceFrom0[i] != 0) {
				if(DEBUG) System.out.println("RatioTable:caclulateRatio():DEBUG: adding ratio 0 to "+i+": signal: "+signalStrengthFrom0[i]+" distance: "+physicalDistanceFrom0[i]);
				ratioList0.add(((double)signalStrengthFrom0[i]) / physicalDistanceFrom0[i]);
			}
			if(physicalDistanceFrom1[i] != 0) {
				if(DEBUG) System.out.println("RatioTable:caclulateRatio():DEBUG: adding ratio 1 to "+i+": signal: "+signalStrengthFrom1[i]+" distance: "+physicalDistanceFrom1[i]);
				ratioList1.add(((double)signalStrengthFrom1[i]) / physicalDistanceFrom1[i]);
			}
			if(physicalDistanceFrom2[i] != 0) {
				if(DEBUG) System.out.println("RatioTable:caclulateRatio():DEBUG: adding ratio 2 to "+i+": signal: "+signalStrengthFrom2[i]+" distance: "+physicalDistanceFrom2[i]);
				ratioList2.add(((double)signalStrengthFrom2[i]) / physicalDistanceFrom2[i]);
			}
			if(physicalDistanceFrom3[i] != 0) {
				if(DEBUG) System.out.println("RatioTable:caclulateRatio():DEBUG: adding ratio 3 to "+i+": signal: "+signalStrengthFrom3[i]+" distance: "+physicalDistanceFrom3[i]);
				ratioList3.add(((double)signalStrengthFrom3[i]) / physicalDistanceFrom3[i]);
			}
			if(physicalDistanceFrom4[i] != 0) {
				if(DEBUG) System.out.println("RatioTable:caclulateRatio():DEBUG: adding ratio 4 to "+i+": signal: "+signalStrengthFrom4[i]+" distance: "+physicalDistanceFrom4[i]);
				ratioList4.add(((double)signalStrengthFrom4[i]) / physicalDistanceFrom4[i]);
			}
		}
		
		double total =0;
		int count=0;
		for(Iterator<Double> i=ratioList0.iterator(); i.hasNext(); ) {
			total += i.next();
			count++;
		}
		
		ratios[0] = total / ((double)count);
		if(DEBUG) System.out.println("RatioTable:caclulateRatio():EXIT: signal to distance ratio - mote 0: "+ratios[0]);
		
		total =0;
		count=0;
		for(Iterator<Double> i=ratioList1.iterator(); i.hasNext(); ) {
			total += i.next();
			count++;
		}
		
		ratios[1] = total / ((double)count);
		if(DEBUG) System.out.println("RatioTable:caclulateRatio():EXIT: signal to distance ratio - mote 1: "+ratios[1]);
		
		total =0;
		count=0;
		for(Iterator<Double> i=ratioList2.iterator(); i.hasNext(); ) {
			total += i.next();
			count++;
		}
		
		ratios[2] = total / ((double)count);
		if(DEBUG) System.out.println("RatioTable:caclulateRatio():EXIT: signal to distance ratio - mote 2: "+ratios[2]);
		
		total =0;
		count=0;
		for(Iterator<Double> i=ratioList3.iterator(); i.hasNext(); ) {
			total += i.next();
			count++;
		}
		
		ratios[3] = total / ((double)count);
		if(DEBUG) System.out.println("RatioTable:caclulateRatio():EXIT: signal to distance ratio - mote 3: "+ratios[3]);
	
		/*total =0;
		count=0;
		for(Iterator<Double> i=ratioList4.iterator(); i.hasNext(); ) {
			total += i.next();
			count++;
		}
		
		ratios[4] = total / ((double)count);
		if(DEBUG) System.out.println("RatioTable:caclulateRatio():EXIT: signal to distance ratio - mote 4: "+ratios[4]);
		*/
	}
	
	public int calculateValueFromSignal(int signal, int moteNum) {
		if(ready)
			return(signal / (int)ratios[moteNum]);
		return(0);
	}

}
