package moteView;

import java.net.*;
import java.io.*;
import java.util.*;

public class SocketListener extends Thread{
	
	private Socket socket;
	
	private boolean listening;
	
	private ArrayList<ByteStreamReciever> recieverList;
	
	//private MoteViewGui gui;
	
	private boolean DEBUG;
	
	public SocketListener(/*MoteViewGui v, */boolean debug) {
		DEBUG = debug;
		if(DEBUG) System.out.println("SocketListener():ENTER:");
		listening = true;
		recieverList = new ArrayList<ByteStreamReciever>();
		//gui = v;
		if(DEBUG) System.out.println("SocketListener():EXIT:");
	}
	
	public void connectSocket(InetAddress address, int port) throws IOException {
		if(DEBUG) System.out.println("SocketListener:connectSocket():ENTER: address: "+address+" port: "+port);
		if(socket != null) {
			if(DEBUG) System.out.println("SocketListener:connectSocket():DEBUG: closing existing socket: "+socket);
			setListening(false);
			socket.close();
			//gui.appendTextMessage("connectSocket():Disconnencting Existing Socket");
		}
		
		
		socket = new Socket(address, port);
		if(DEBUG) System.out.println("SocketListener:connectSocket():DEBUG: socket created: "+socket);
		//gui.appendTextMessage("connectSocket():Connected Socket-- "+address+""+port);
		if(DEBUG) System.out.println("SocketListener:connectSocket():EXIT: address: "+address+" port: "+port);
	}
	
	public void closeSocket() {
		if(DEBUG) System.out.println("SocketListener:closeSocket():ENTER: ");
		if(socket != null) {
			setListening(false);
			try {
				socket.close();
				if(DEBUG) System.out.println("SocketListener:closeSocket():DEBUG: closing existing socket: "+socket);
				//gui.appendTextMessage("closeSocket():Disconnencting Socket");
			}
			catch(IOException ex){}
		}
		if(DEBUG) System.out.println("SocketListener:closeSocket():EXIT: ");
	}
	
	private synchronized void setListening(boolean val) {
		if(DEBUG) System.out.println("SocketListener:setListening():ENTER: "+val);
		//gui.appendTextMessage("setListening():Disconnencting Socket");
		listening = val;
		if(DEBUG) System.out.println("SocketListener:setListening():EXIT: ");
	}
	
	private synchronized boolean isListening() {
		return(listening);
	}
	
	public void run() {
		if(DEBUG) System.out.println("SocketListener:run():ENTER: ");
		if(socket == null) {
			if(DEBUG) System.out.println("SocketListener:run():ERROR: socket is null");
			throw new AssertionError("Socket not connected on start");
		}
		try {
			InputStream iStream = socket.getInputStream();
			byte[] byteArray = new byte[1024];
			if(DEBUG) System.out.println("SocketListener:run():DEBUG: entering loop: isListening = "+isListening());
			while(isListening()) {
				//listen to socket, output data to recieverList
				int bytesRead = iStream.read(byteArray);
				if(bytesRead != -1)
					for(Iterator<ByteStreamReciever> i = recieverList.iterator(); i.hasNext();) {
						ByteStreamReciever rec = i.next();
						rec.recieveByteStream(byteArray);
					}
			}
			if(DEBUG) System.out.println("SocketListener:run():DEBUG: leaving loop");
		}
		catch(IOException ex) {
			if(DEBUG) System.out.println("SocketListener:run():DEBUG: IOException: "+ex.getMessage());
			for(Iterator<ByteStreamReciever> i = recieverList.iterator(); i.hasNext();) {
				ByteStreamReciever rec = i.next();
				rec.handleIOException(ex);
			}
		}
		if(DEBUG) System.out.println("SocketListener:run():EXIT: ");	
	}
	
	public void setPause(boolean val) {
		setListening(val);
	}
	
	public void registerByteStreamReciever(ByteStreamReciever bStream) {
		if(!recieverList.contains(bStream))
			recieverList.add(bStream);
	}
	
	public void removeByteStreamReciever(ByteStreamReciever bStream) {
		recieverList.remove(bStream);
	}
	
	public void unregisterAllRecievers() {
		recieverList.clear();
	}

}
